# OpenPBX Database Export from 2013-02-20_16-41-37
# DB_VERSION=3

BEGIN TRANSACTION;
CREATE TABLE activate (id VARCHAR(15) PRIMARY KEY,option INTEGER DEFAULT 0);
INSERT INTO activate (id,option) VALUES('activate',0);
CREATE TABLE sip_extensions (id INTEGER AUTOINCREMENT PRIMARY KEY,extension VARCHAR(16) NOT NULL DEFAULT '0');
INSERT INTO sip_extensions (id,extension) VALUES(0,'Any Extension');
CREATE TABLE sip_users (id INTEGER AUTOINCREMENT PRIMARY KEY,name VARCHAR(64) NOT NULL DEFAULT '',extension INTEGER NOT NULL DEFAULT '0',password VARCHAR(256) NOT NULL DEFAULT '',voicemail INTEGER(1) NOT NULL DEFAULT 0,send_from_user INTEGER(1) NOT NULL DEFAULT 0,mail VARCHAR(256) NOT NULL DEFAULT '',language VARCHAR(5) NOT NULL DEFAULT 'en',details VARCHAR(512) NOT NULL DEFAULT '',CONSTRAINT fk_sip_extensions_id FOREIGN KEY(extension) REFERENCES sip_extensions(id) ON DELETE SET DEFAULT);
CREATE TABLE sip_groups (id INTEGER AUTOINCREMENT PRIMARY KEY,name VARCHAR(64) NOT NULL DEFAULT '',extension INTEGER NOT NULL DEFAULT '0',voicemail INTEGER(1) NOT NULL DEFAULT 0,mail VARCHAR(256) NOT NULL DEFAULT '',description VARCHAR(256) NOT NULL DEFAULT '',CONSTRAINT fk_sip_extensions_id FOREIGN KEY(extension) REFERENCES sip_extensions(id) ON DELETE SET DEFAULT);
CREATE TABLE sip_rel_user_group (id INTEGER AUTOINCREMENT PRIMARY KEY,userid INTEGER NOT NULL DEFAULT '0',groupid INTEGER NOT NULL DEFAULT '0',CONSTRAINT fk_sip_users_id FOREIGN KEY (userid) REFERENCES sip_users(id) ON DELETE CASCADE,CONSTRAINT fk_sip_groups_id FOREIGN KEY (groupid) REFERENCES sip_groups(id) ON DELETE CASCADE);
CREATE TABLE mail_settings (id INTEGER AUTOINCREMENT PRIMARY KEY,smtp_host VARCHAR(128) NOT NULL DEFAULT '',smtp_port INTEGER NOT NULL DEFAULT 25,smtp_user VARCHAR(128) NOT NULL DEFAULT '',smtp_pass VARCHAR(128) NOT NULL DEFAULT '',smtp_from VARCHAR(128) NOT NULL DEFAULT '');
INSERT INTO mail_settings (id,smtp_host,smtp_port,smtp_user,smtp_pass,smtp_from) VALUES(1,'',25,'','','');
CREATE TABLE phone_types (id INTEGER PRIMARY KEY, name VARCHAR(60));
INSERT INTO phone_types (id,name) VALUES(1,'snom300');
INSERT INTO phone_types (id,name) VALUES(2,'snom320');
INSERT INTO phone_types (id,name) VALUES(3,'snom360');
INSERT INTO phone_types (id,name) VALUES(4,'snom370');
INSERT INTO phone_types (id,name) VALUES(5,'snom720');
INSERT INTO phone_types (id,name) VALUES(6,'snom760');
INSERT INTO phone_types (id,name) VALUES(7,'snom820');
INSERT INTO phone_types (id,name) VALUES(8,'snom821');
INSERT INTO phone_types (id,name) VALUES(9,'snom870');
CREATE TABLE phone_devices (id INTEGER AUTOINCREMENT PRIMARY KEY,name VARCHAR(64) NOT NULL DEFAULT '', ipaddr VARCHAR(16) NOT NULL DEFAULT '',macaddr VARCHAR(12) NOT NULL DEFAULT '',typeid INTEGER NOT NULL DEFAULT '1', tmplid INTEGER NOT NULL DEFAULT '1',userid INTEGER NOT NULL DEFAULT '0', CONSTRAINT fk_sip_users_id FOREIGN KEY (userid) REFERENCES sip_users(id) ON DELETE SET DEFAULT,CONSTRAINT fk_phone_types_id FOREIGN KEY (typeid) REFERENCES phone_types(id) ON DELETE SET DEFAULT,CONSTRAINT fk_phone_templates_id FOREIGN KEY (tmplid) REFERENCES phone_templates(id) ON DELETE SET DEFAULT);
CREATE TABLE phone_templates (id INTEGER PRIMARY KEY,name VARCHAR(60),description VARCHAR(120),path VARCHAR(60),readonly INTEGER);
INSERT INTO phone_templates (id,name,description,path,readonly) VALUES(1,'snom_default','SNOM default template','/apps/OpenPBX/etc/settings/default/snom.xml',1);
CREATE TABLE phone_pnp_managed (id INTEGER AUTOINCREMENT PRIMARY KEY, mac VARCHAR(12), enabled INTEGER(1) NOT NULL DEFAULT '0');
INSERT INTO phone_pnp_managed (id,mac,enabled) VALUES(0,'FFFFFFFFFFFF',0);
CREATE TABLE sip_dtmfmodes (id INTEGER AUTOINCREMENT PRIMARY KEY,name VARCHAR(16) NOT NULL DEFAULT '');
INSERT INTO sip_dtmfmodes (id,name) VALUES(1,'rfc2833');
INSERT INTO sip_dtmfmodes (id,name) VALUES(2,'inband');
INSERT INTO sip_dtmfmodes (id,name) VALUES(3,'info');
CREATE TABLE sip_trunks (id INTEGER AUTOINCREMENT PRIMARY KEY,name VARCHAR(60) NOT NULL DEFAULT '',user VARCHAR(60) NOT NULL DEFAULT '',password VARCHAR(60) NOT NULL DEFAULT '',registrar VARCHAR(60) NOT NULL DEFAULT '',proxy VARCHAR(60) NOT NULL DEFAULT '',send_from_user INTEGER(1) NOT NULL DEFAULT 0,dtmfmode INTEGER NOT NULL DEFAULT '0',details VARCHAR(250) NOT NULL DEFAULT '',CONSTRAINT fk_sip_dtmfmodes_id FOREIGN KEY (dtmfmode) REFERENCES sip_dtmfmodes(id) ON DELETE SET DEFAULT);
INSERT INTO sip_trunks (id,name,user,password,registrar,proxy,send_from_user,dtmfmode,details) VALUES(0,'Any Trunk','','','','',0,0,'');
CREATE TABLE sip_codecs (id INTEGER AUTOINCREMENT PRIMARY KEY,name VARCHAR(64) NOT NULL DEFAULT '');
INSERT INTO sip_codecs (id,name) VALUES(1,'all');
INSERT INTO sip_codecs (id,name) VALUES(2,'alaw');
INSERT INTO sip_codecs (id,name) VALUES(3,'gsm');
INSERT INTO sip_codecs (id,name) VALUES(4,'ilbc');
INSERT INTO sip_codecs (id,name) VALUES(5,'ulaw');
CREATE TABLE sip_rel_trunk_codec (id INTEGER AUTOINCREMENT PRIMARY KEY,priority INTEGER NOT NULL DEFAULT '1',codecid INTEGER NOT NULL DEFAULT '0',trunkid INTEGER NOT NULL DEFAULT '0',CONSTRAINT fk_codecs_id FOREIGN KEY (codecid) REFERENCES codecs(id) ON DELETE SET DEFAULT,CONSTRAINT fk_sip_trunks_id FOREIGN KEY (trunkid) REFERENCES sip_trunks(id) ON DELETE CASCADE);
CREATE TABLE rules_action (id INTEGER AUTOINCREMENT PRIMARY KEY,name VARCHAR(16));
INSERT INTO rules_action (id,name) VALUES(0,'none');
INSERT INTO rules_action (id,name) VALUES(1,'dial');
INSERT INTO rules_action (id,name) VALUES(2,'hangup');
INSERT INTO rules_action (id,name) VALUES(3,'voicemail');
INSERT INTO rules_action (id,name) VALUES(4,'disa');
CREATE TABLE rules_type (id INTEGER AUTOINCREMENT PRIMARY KEY,name VARCHAR(16) NOT NULL DEFAULT '');
INSERT INTO rules_type (id,name) VALUES(1,'inbound');
INSERT INTO rules_type (id,name) VALUES(2,'outbound');
CREATE TABLE call_rules (id INTEGER AUTOINCREMENT PRIMARY KEY,typeid INTEGER NUT NULL DEFAULT '0',extid INTEGER NOT NULL DEFAULT '0',position INTEGER NOT NULL DEFAULT '1',number VARCHAR(128) NOT NULL DEFAULT '*',actionid INTEGER NOT NULL DEFAULT '0',action_1 VARCHAR(128) NOT NULL DEFAULT '',action_2 VARCHAR(128) NOT NULL DEFAULT '',trunkid INTEGER NOT NULL DEFAULT '0',CONSTRAINT fk_sip_extensions_id FOREIGN KEY (extid) REFERENCES sip_extensions(id) ON DELETE CASCADE,CONSTRAINT fk_rules_type_id FOREIGN KEY (typeid) REFERENCES rules_type(id) ON DELETE CASCADE,CONSTRAINT fk_rules_action_id FOREIGN KEY (actionid) REFERENCES rules_action(id) ON DELETE CASCADE,CONSTRAINT fk_sip_trunks_id FOREIGN KEY (trunkid) REFERENCES sip_trunks(id) ON DELETE CASCADE);
CREATE VIEW call_rules_outbound AS SELECT r.id AS id,r.number AS Target,e.extension AS Extension,a.name AS Action,r.action_1 AS action_1,r.action_2 AS action_2,t.name AS Trunk FROM call_rules AS r,rules_action AS a, sip_extensions AS e,sip_trunks AS t WHERE r.typeid = '2' AND a.id = r.actionid AND e.id = r.extid AND t.id = r.trunkid GROUP BY r.number ORDER BY r.position ASC;
CREATE VIEW call_rules_inbound AS SELECT r.id AS id,r.number AS Source,e.extension AS Extension,a.name AS Action,r.action_1 AS action_1,r.action_2 AS action_2,t.name AS Trunk FROM call_rules AS r,rules_action AS a, sip_extensions AS e,sip_trunks AS t WHERE r.typeid = '1' AND a.id = r.actionid AND e.id = r.extid AND t.id = r.trunkid GROUP BY r.number ORDER BY r.position ASC;
COMMIT;
